#!/bin/ash
[[ -x ../../../src/gtkdialog1 ]] && PATH=../../../src:$PATH

#initial value for display
echo -n > /tmp/calc
echo -n > /tmp/add

#ash function file
echo '
#the calculator itself:
calc () {
	awk "BEGIN { print $* }"
}

write_me () {
myvar=$(cat /tmp/calc)
case $1 in
	[0-9]|.)	echo -n ${1} >> /tmp/calc;;
	x2)			calc $myvar*$myvar > /tmp/calc;;
	SQ)			calc "sqrt ( $myvar )" > /tmp/calc;;
	RE)			calc 1/$myvar > /tmp/calc;;
	PC)			calc $myvar/100 > /tmp/calc;;
	IN)			calc "int ( $myvar ) " > /tmp/calc;;
	LG)			calc "log ( $myvar ) " > /tmp/calc;;
	VT)			calc " -1 * $myvar " > /tmp/calc;;
	C)			echo -n > /tmp/calc;;
	CE)			echo -n > /tmp/calc
				echo -n > /tmp/add;;	
esac
}

add_me () {
cat /tmp/calc >> /tmp/add
if [ "$1" = "M" ]; then
	   echo -n "*" >> /tmp/add
else
	echo -n "${1}" >> /tmp/add
fi
echo -n > /tmp/calc
}

calc_me () {
cat /tmp/calc >> /tmp/add
myvar=$(cat /tmp/add)
calc $myvar > /tmp/calc
echo -n > /tmp/add
}

' > /tmp/ashcalc

export MAIN_DIALOG='
<wtitle>Calculator</wtitle>
<vbox>
	<entry>
		<input>cat /tmp/calc</input>
		<variable>ENTRY</variable>
	</entry>
#1.col
	<hbox>
		<vbox>
			<button>
				<label>CE</label>
				<action>clear:ENTRY</action>
				<action>write_me CE</action>
				<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>%</label>
			<action>write_me PC</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>1/x</label>
			<action>write_me RE</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>sqrt</label>
			<action>write_me SQ</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>x^2</label>
			<action>write_me x2</action>
			<action>refresh:ENTRY</action>
		</button>	
	</vbox>
#2.col
	<vbox>
		<button>
			<label>C</label>
			<action>clear:ENTRY</action>
			<action>write_me C</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>7</label>
			<action>write_me 7</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>4</label>
			<action>write_me 4</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>1</label>
			<action>write_me 1</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>0</label>
			<action>write_me 0</action>
			<action>refresh:ENTRY</action>
		</button>	
	</vbox>	
#3.col
	<vbox>
		<button>
			<label>INT</label>
			<action>clear:ENTRY</action>
			<action>write_me IN</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>8</label>
			<action>write_me 8</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>5</label>
			<action>write_me 5</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>2</label>
			<action>write_me 2</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>.</label>
			<action>write_me .</action>
			<action>refresh:ENTRY</action>
		</button>	
	</vbox>	
#4.col
	<vbox>
		<button>
			<label>ln</label>
			<action>clear:ENTRY</action>
			<action>write_me LG</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>9</label>
			<action>write_me 9</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>6</label>
			<action>write_me 6</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>3</label>
			<action>write_me 3</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>+/-</label>
			<action>clear:ENTRY</action>
			<action>write_me VT</action>
			<action>refresh:ENTRY</action>
		</button>	
	</vbox>	
#5.col
	<vbox>
		<button>
			<label>/</label>
			<action>add_me /</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>*</label>
			<action>add_me M</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>-</label>
			<action>add_me -</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>+</label>
			<action>add_me +</action>
			<action>refresh:ENTRY</action>
		</button>
		<button>
			<label>=</label>
			<action>calc_me</action>
			<action>refresh:ENTRY</action>
		</button>	
	</vbox>	
</hbox>
</vbox>	
'

gtkdialog1 --center --wmclass calculator --program=MAIN_DIALOG -i /tmp/ashcalc